curl --request POST \
--url https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
'import requests
url = "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish"
payload = {
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
message: 'osd.22 reports a firmware impending failure',
subject: 'Disk pressure on europa',
message_structure: 'json',
attributes: {
severity: {type: 'String', value: 'critical'},
latency: {type: 'Number', value: '250'}
}
})
};
fetch('https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'message' => 'osd.22 reports a firmware impending failure',
'subject' => 'Disk pressure on europa',
'message_structure' => 'json',
'attributes' => [
'severity' => [
'type' => 'String',
'value' => 'critical'
],
'latency' => [
'type' => 'Number',
'value' => '250'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish"
payload := strings.NewReader("{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"message_id": "019400aa-bbbb-7ccc-8ddd-eeeeffff0000"
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Publicar uma notificação
Retorna 202 após persistir e enfileirar a notificação. A distribuição ainda não ocorreu; delivery_count permanece 0 até ela terminar.
curl --request POST \
--url https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
'import requests
url = "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish"
payload = {
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
message: 'osd.22 reports a firmware impending failure',
subject: 'Disk pressure on europa',
message_structure: 'json',
attributes: {
severity: {type: 'String', value: 'critical'},
latency: {type: 'Number', value: '250'}
}
})
};
fetch('https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'message' => 'osd.22 reports a firmware impending failure',
'subject' => 'Disk pressure on europa',
'message_structure' => 'json',
'attributes' => [
'severity' => [
'type' => 'String',
'value' => 'critical'
],
'latency' => [
'type' => 'Number',
'value' => '250'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish"
payload := strings.NewReader("{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"message_id": "019400aa-bbbb-7ccc-8ddd-eeeeffff0000"
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}notifications:Publish. Veja NOTIFICATIONS permissões para a lista completa, o escopo de cada ação e um exemplo de política.Autorizações
Um token bearer OAuth 2.0, enviado como Authorization: Bearer <token>. Esta é a forma recomendada de autenticação.
Obtenha o token trocando o par de chaves de acesso de uma conta de serviço em POST /v1/oauth/token com grant_type=client_credentials. Esse é o fluxo padrão de credenciais de cliente; bibliotecas compatíveis com OAuth podem obter e renovar o token para você.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Os tokens duram uma hora por padrão. O mesmo par de chaves de acesso também serve como credencial AWS SigV4 para o endpoint de objetos compatível com S3, que aceita somente esse método de autenticação.
Cabeçalhos
Chave opcional gerada pelo cliente que torna uma criação segura para reprodução. A reintentar uma solicitação com a mesma chave retorna o resultado original literalmente em vez de criar um recurso duplicado. A reutilização de uma chave com um corpo de solicitação diferente é rejeitada (422); uma solicitação cuja chave ainda está sendo processada retorna 409. Os registros são honrados por 24 horas. Use um UUID ou token exclusivo semelhante.
255Parâmetros de caminho
"a1b2c3d4-5e6f-4a7b-8c9d-0e1f2a3b4c5d"
Corpo
Conteúdo. Até 256 KiB.
262144"osd.22 reports a firmware impending failure"
Usado como assunto do email. Sem quebras de linha.
100"Disk pressure on europa"
Omita para entregar message sem alterações. Use json para interpretar message como um objeto com chaves default, email, https e http, permitindo conteúdo por protocolo. default é obrigatório e cobre protocolos sem entrada própria.
, json "json"
Atributos tipados comparados com políticas de filtro. Até 20 atributos, com valores de até 1024 bytes. Atributos binários não são aceitos porque não podem ser filtrados.
Show child attributes
Show child attributes
{
"severity": { "type": "String", "value": "critical" },
"latency": { "type": "Number", "value": "250" }
}
Resposta
Notificação aceita para entrega.
"019400aa-bbbb-7ccc-8ddd-eeeeffff0000"

